JsonParser (Jackson-core 2.1.1 API)
Date: 2012-11-11

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.fasterxml.jackson.core
Class JsonParser

    java.lang.Object
      com.fasterxml.jackson.core.JsonParser

All Implemented Interfaces:
  Versioned, Closeable

Direct Known Subclasses:
  JsonParserDelegate, ParserMinimalBase

    public abstract class JsonParser

extends Object
implements Closeable, Versioned

Base class that defines public API for reading JSON content. Instances are created using factory methods of a `JsonFactory` instance.

Author:
  Tatu Saloranta

Nested Class Summary
`static class` | `JsonParser.Feature` Enumeration that defines all on/off features for parsers.
`static class` | `JsonParser.NumberType` Enumeration of possible "native" (optimal) types that can be used for numbers.

Field Summary
`protected int` | `_features` Bit flag composed of bits that indicate which `JsonParser.Feature`s are enabled.

Constructor Summary
`protected` | `JsonParser()`
`protected` | `JsonParser(int features)`

Method Summary
`protected JsonParseException` | `_constructError(String msg)` Helper method for constructing `JsonParseException`s based on current state of the parser
`protected void` | `_reportUnsupportedOperation()` Helper method to call for operations that are not supported by parser implementation.
`boolean` | `canUseSchema(FormatSchema schema)` Method that can be used to verify that given schema can be used with this parser (using `setSchema(com.fasterxml.jackson.core.FormatSchema)`).
`abstract void` | `clearCurrentToken()` Method called to "consume" the current token by effectively removing it so that `hasCurrentToken()` returns false, and `getCurrentToken()` null).
`abstract void` | `close()` Closes the parser so that no further iteration or data access can be made; will also close the underlying input source if parser either owns the input source, or feature `JsonParser.Feature.AUTO_CLOSE_SOURCE` is enabled.
`JsonParser` | `configure(JsonParser.Feature f, boolean state)` Method for enabling or disabling specified feature (check `JsonParser.Feature` for list of features)
`JsonParser` | `disable(JsonParser.Feature f)` Method for disabling specified feature (check `JsonParser.Feature` for list of features)
`JsonParser` | `enable(JsonParser.Feature f)` Method for enabling specified parser feature (check `JsonParser.Feature` for list of features)
`abstract BigInteger` | `getBigIntegerValue()` Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can not be used as a Java long primitive type due to its magnitude.
`byte[]` | `getBinaryValue()` Convenience alternative to `getBinaryValue(Base64Variant)` that defaults to using `Base64Variants.getDefaultVariant()` as the default encoding.
`abstract byte[]` | `getBinaryValue(Base64Variant b64variant)` Method that can be used to read (and consume -- results may not be accessible using other methods after the call) base64-encoded binary data included in the current textual JSON value.
`boolean` | `getBooleanValue()` Convenience accessor that can be called when the current token is `JsonToken.VALUE_TRUE` or `JsonToken.VALUE_FALSE`.
`byte` | `getByteValue()` Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a value of Java byte primitive type.
`abstract ObjectCodec` | `getCodec()` Accessor for `ObjectCodec` associated with this parser, if any.
`abstract JsonLocation` | `getCurrentLocation()` Method that returns location of the last processed character; usually for error reporting purposes.
`abstract String` | `getCurrentName()` Method that can be called to get the name associated with the current token: for `JsonToken.FIELD_NAME`s it will be the same as what `getText()` returns; for field values it will be preceding field name; and for others (array values, root-level values) null.
`abstract JsonToken` | `getCurrentToken()` Accessor to find which token parser currently points to, if any; null will be returned if none.
`abstract BigDecimal` | `getDecimalValue()` Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` or `JsonToken.VALUE_NUMBER_INT`.
`abstract double` | `getDoubleValue()` Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` and it can be expressed as a Java double primitive type.
`abstract Object` | `getEmbeddedObject()` Accessor that can be called if (and only if) the current token is `JsonToken.VALUE_EMBEDDED_OBJECT`.
`abstract float` | `getFloatValue()` Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` and it can be expressed as a Java float primitive type.
`Object` | `getInputSource()` Method that can be used to get access to object that is used to access input being parsed; this is usually either `InputStream` or `Reader`, depending on what parser was constructed with.
`abstract int` | `getIntValue()` Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a value of Java int primitive type.
`abstract JsonToken` | `getLastClearedToken()` Method that can be called to get the last token that was cleared using `clearCurrentToken()`.
`abstract long` | `getLongValue()` Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a Java long primitive type.
`abstract JsonParser.NumberType` | `getNumberType()` If current token is of type `JsonToken.VALUE_NUMBER_INT` or `JsonToken.VALUE_NUMBER_FLOAT`, returns one of `JsonParser.NumberType` constants; otherwise returns null.
`abstract Number` | `getNumberValue()` Generic number value accessor method that will work for all kinds of numeric values.
`abstract JsonStreamContext` | `getParsingContext()` Method that can be used to access current parsing context reader is in.
`FormatSchema` | `getSchema()` Method for accessing Schema that this parser uses, if any.
`short` | `getShortValue()` Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a value of Java short primitive type.
`abstract String` | `getText()` Method for accessing textual representation of the current token; if no current token (before first call to `nextToken()`, or after encountering end-of-input), returns null.
`abstract char[]` | `getTextCharacters()` Method similar to `getText()`, but that will return underlying (unmodifiable) character array that contains textual value, instead of constructing a String object to contain this information.
`abstract int` | `getTextLength()` Accessor used with `getTextCharacters()`, to know length of String stored in returned buffer.
`abstract int` | `getTextOffset()` Accessor used with `getTextCharacters()`, to know offset of the first text content character within buffer.
`abstract JsonLocation` | `getTokenLocation()` Method that return the starting location of the current token; that is, position of the first character from input that starts the current token.
`boolean` | `getValueAsBoolean()` Method that will try to convert value of current token to a boolean.
`boolean` | `getValueAsBoolean(boolean defaultValue)` Method that will try to convert value of current token to a boolean.
`double` | `getValueAsDouble()` Method that will try to convert value of current token to a Java double.
`double` | `getValueAsDouble(double defaultValue)` Method that will try to convert value of current token to a Java double.
`int` | `getValueAsInt()` Method that will try to convert value of current token to a int.
`int` | `getValueAsInt(int defaultValue)` Method that will try to convert value of current token to a int.
`long` | `getValueAsLong()` Method that will try to convert value of current token to a long.
`long` | `getValueAsLong(long defaultValue)` Method that will try to convert value of current token to a long.
`String` | `getValueAsString()` Method that will try to convert value of current token to a `String`.
`abstract String` | `getValueAsString(String defaultValue)` Method that will try to convert value of current token to a `String`.
`abstract boolean` | `hasCurrentToken()` Method for checking whether parser currently points to a token (and data for that token is available).
`abstract boolean` | `hasTextCharacters()` Method that can be used to determine whether calling of `getTextCharacters()` would be the most efficient way to access textual content for the event parser currently points to.
`abstract boolean` | `isClosed()` Method that can be called to determine whether this parser is closed or not.
`boolean` | `isEnabled(JsonParser.Feature f)` Method for checking whether specified `JsonParser.Feature` is enabled.
`boolean` | `isExpectedStartArrayToken()` Specialized accessor that can be used to verify that the current token indicates start array (usually meaning that current token is `JsonToken.START_ARRAY`) when start array is expected.
`Boolean` | `nextBooleanValue()` Method that fetches next token (as if calling `nextToken()`) and if it is `JsonToken.VALUE_TRUE` or `JsonToken.VALUE_FALSE` returns matching Boolean value; otherwise return null.
`boolean` | `nextFieldName(SerializableString str)` Method that fetches next token (as if calling `nextToken()`) and verifies whether it is `JsonToken.FIELD_NAME` with specified name and returns result of that comparison.
`int` | `nextIntValue(int defaultValue)` Method that fetches next token (as if calling `nextToken()`) and if it is `JsonToken.VALUE_NUMBER_INT` returns 32-bit int value; otherwise returns specified default value It is functionally equivalent to:
`long` | `nextLongValue(long defaultValue)` Method that fetches next token (as if calling `nextToken()`) and if it is `JsonToken.VALUE_NUMBER_INT` returns 64-bit long value; otherwise returns specified default value It is functionally equivalent to:
`String` | `nextTextValue()` Method that fetches next token (as if calling `nextToken()`) and if it is `JsonToken.VALUE_STRING` returns contained String value; otherwise returns null.
`abstract JsonToken` | `nextToken()` Main iteration method, which will advance stream enough to determine type of the next token, if any.
`abstract JsonToken` | `nextValue()` Iteration method that will advance stream enough to determine type of the next token that is a value type (including JSON Array and Object start/end markers).
`abstract void` | `overrideCurrentName(String name)` Method that can be used to change what is considered to be the current (field) name.
`int` | `readBinaryValue(Base64Variant b64variant, OutputStream out)` Similar to `readBinaryValue(OutputStream)` but allows explicitly specifying base64 variant to use.
`int` | `readBinaryValue(OutputStream out)` Method that can be used as an alternative to `getBigIntegerValue()`, especially when value can be large.
`
`<T> T`
` | `readValueAs(Class<T> valueType)` Method to deserialize JSON content into a non-container type (it can be an array type, however): typically a bean, array or a wrapper type (like `Boolean`).
`
`<T> T`
` | `readValueAs(TypeReference<?> valueTypeRef)` Method to deserialize JSON content into a Java type, reference to which is passed as argument.
`
`<T extends TreeNode> T`
` | `readValueAsTree()` Method to deserialize JSON content into equivalent "tree model", represented by root `TreeNode` of resulting model.
`
`<T> Iterator<T>`
` | `readValuesAs(Class<T> valueType)` Method for reading sequence of Objects from parser stream, all with same specified value type.
`
`<T> Iterator<T>`
` | `readValuesAs(TypeReference<?> valueTypeRef)` Method for reading sequence of Objects from parser stream, all with same specified value type.
`int` | `releaseBuffered(OutputStream out)` Method that can be called to push back any content that has been read but not consumed by the parser.
`int` | `releaseBuffered(Writer w)` Method that can be called to push back any content that has been read but not consumed by the parser.
`boolean` | `requiresCustomCodec()` Method that can be called to determine if a custom `ObjectCodec` is needed for binding data parsed using `JsonParser` constructed by this factory (which typically also implies the same for serialization with `JsonGenerator`).
`abstract void` | `setCodec(ObjectCodec c)` Setter that allows defining `ObjectCodec` associated with this parser, if any.
`void` | `setSchema(FormatSchema schema)` Method to call to make this parser use specified schema.
`abstract JsonParser` | `skipChildren()` Method that will skip all child tokens of an array or object token that the parser currently points to, iff stream points to `JsonToken.START_OBJECT` or `JsonToken.START_ARRAY`.
`abstract Version` | `version()` Accessor for getting version of the core package, given a parser instance.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### _features

    protected int _features

  Bit flag composed of bits that indicate which `JsonParser.Feature`s are enabled.

Constructor Detail

### JsonParser

    protected JsonParser()

### JsonParser

    protected JsonParser(int features)

Method Detail

### getCodec

    public abstract ObjectCodec getCodec()

  Accessor for `ObjectCodec` associated with this parser, if any. Codec is used by `readValueAs(Class)` method (and its variants).

### setCodec

    public abstract void setCodec(ObjectCodec c)

  Setter that allows defining `ObjectCodec` associated with this parser, if any. Codec is used by `readValueAs(Class)` method (and its variants).

### getInputSource

    public Object getInputSource()

  Method that can be used to get access to object that is used to access input being parsed; this is usually either `InputStream` or `Reader`, depending on what parser was constructed with. Note that returned value may be null in some cases; including case where parser implementation does not want to exposed raw source to caller. In cases where input has been decorated, object returned here is the decorated version; this allows some level of interaction between users of parser and decorator object.

  In general use of this accessor should be considered as "last effort", i.e. only used if no other mechanism is applicable.

### setSchema

    public void setSchema(FormatSchema schema)

  Method to call to make this parser use specified schema. Method must be called before trying to parse any content, right after parser instance has been created. Note that not all parsers support schemas; and those that do usually only accept specific types of schemas: ones defined for data format parser can read.

  If parser does not support specified schema, `UnsupportedOperationException` is thrown.

  Parameters:
    `schema` - Schema to use
  Throws:
    `UnsupportedOperationException` - if parser does not support schema

### getSchema

    public FormatSchema getSchema()

  Method for accessing Schema that this parser uses, if any. Default implementation returns null.

  Since:
    2.1

### canUseSchema

    public boolean canUseSchema(FormatSchema schema)

  Method that can be used to verify that given schema can be used with this parser (using `setSchema(com.fasterxml.jackson.core.FormatSchema)`).

  Parameters:
    `schema` - Schema to check
  Returns:
    True if this parser can use given schema; false if not

### requiresCustomCodec

    public boolean requiresCustomCodec()

  Method that can be called to determine if a custom `ObjectCodec` is needed for binding data parsed using `JsonParser` constructed by this factory (which typically also implies the same for serialization with `JsonGenerator`).

  Returns:
    True if custom codec is needed with parsers and generators created by this factory; false if a general `ObjectCodec` is enough
  Since:
    2.1

### version

    public abstract Version version()

  Accessor for getting version of the core package, given a parser instance. Left for sub-classes to implement.

  Specified by:
    `version` in interface `Versioned`

### close

    public abstract void close()
                        throws IOException

  Closes the parser so that no further iteration or data access can be made; will also close the underlying input source if parser either owns the input source, or feature `JsonParser.Feature.AUTO_CLOSE_SOURCE` is enabled. Whether parser owns the input source depends on factory method that was used to construct instance (so check `JsonFactory` for details, but the general idea is that if caller passes in closable resource (such as `InputStream` or `Reader`) parser does NOT own the source; but if it passes a reference (such as `File` or `URL` and creates stream or reader it does own them.

  Specified by:
    `close` in interface `Closeable`
  Throws:
    `IOException`

### releaseBuffered

    public int releaseBuffered(OutputStream out)
                        throws IOException

  Method that can be called to push back any content that has been read but not consumed by the parser. This is usually done after reading all content of interest using parser. Content is released by writing it to given stream if possible; if underlying input is byte-based it can released, if not (char-based) it can not.

  Returns:
    -1 if the underlying content source is not byte based (that is, input can not be sent to `OutputStream`; otherwise number of bytes released (0 if there was nothing to release)
  Throws:
    `IOException` - if write to stream threw exception

### releaseBuffered

    public int releaseBuffered(Writer w)
                        throws IOException

  Method that can be called to push back any content that has been read but not consumed by the parser. This is usually done after reading all content of interest using parser. Content is released by writing it to given writer if possible; if underlying input is char-based it can released, if not (byte-based) it can not.

  Returns:
    -1 if the underlying content source is not char-based (that is, input can not be sent to `Writer`; otherwise number of chars released (0 if there was nothing to release)
  Throws:
    `IOException` - if write using Writer threw exception

### enable

    public JsonParser enable(JsonParser.Feature f)

  Method for enabling specified parser feature (check `JsonParser.Feature` for list of features)

### disable

    public JsonParser disable(JsonParser.Feature f)

  Method for disabling specified feature (check `JsonParser.Feature` for list of features)

### configure

    public JsonParser configure(JsonParser.Feature f,
                                boolean state)

  Method for enabling or disabling specified feature (check `JsonParser.Feature` for list of features)

### isEnabled

    public boolean isEnabled(JsonParser.Feature f)

  Method for checking whether specified `JsonParser.Feature` is enabled.

### nextToken

    public abstract JsonToken nextToken()
                                 throws IOException,
                                        JsonParseException

  Main iteration method, which will advance stream enough to determine type of the next token, if any. If none remaining (stream has no content other than possible white space before ending), null will be returned.

  Returns:
    Next token from the stream, if any found, or null to indicate end-of-input
  Throws:
    `IOException`
    `JsonParseException`

### nextValue

    public abstract JsonToken nextValue()
                                 throws IOException,
                                        JsonParseException

  Iteration method that will advance stream enough to determine type of the next token that is a value type (including JSON Array and Object start/end markers). Or put another way, nextToken() will be called once, and if `JsonToken.FIELD_NAME` is returned, another time to get the value for the field. Method is most useful for iterating over value entries of JSON objects; field name will still be available by calling `getCurrentName()` when parser points to the value.

  Returns:
    Next non-field-name token from the stream, if any found, or null to indicate end-of-input (or, for non-blocking parsers, `JsonToken.NOT_AVAILABLE` if no tokens were available yet)
  Throws:
    `IOException`
    `JsonParseException`

### nextFieldName

    public boolean nextFieldName(SerializableString str)
                          throws IOException,
                                 JsonParseException

  Method that fetches next token (as if calling `nextToken()`) and verifies whether it is `JsonToken.FIELD_NAME` with specified name and returns result of that comparison. It is functionally equivalent to:

        return (nextToken() == JsonToken.FIELD_NAME) && str.getValue().equals(getCurrentName());

  but may be faster for parser to verify, and can therefore be used if caller expects to get such a property name from input next.

  Parameters:
    `str` - Property name to compare next token to (if next token is `JsonToken.FIELD_NAME`)``
  Throws:
    `IOException`
    `JsonParseException`

### nextTextValue

    public String nextTextValue()
                         throws IOException,
                                JsonParseException

  Method that fetches next token (as if calling `nextToken()`) and if it is `JsonToken.VALUE_STRING` returns contained String value; otherwise returns null. It is functionally equivalent to:

        return (nextToken() == JsonToken.VALUE_STRING) ? getText() : null;

  but may be faster for parser to process, and can therefore be used if caller expects to get a String value next from input.

  Throws:
    `IOException`
    `JsonParseException`

### nextIntValue

    public int nextIntValue(int defaultValue)
                     throws IOException,
                            JsonParseException

  Method that fetches next token (as if calling `nextToken()`) and if it is `JsonToken.VALUE_NUMBER_INT` returns 32-bit int value; otherwise returns specified default value It is functionally equivalent to:

        return (nextToken() == JsonToken.VALUE_NUMBER_INT) ? getIntValue() : defaultValue;

  but may be faster for parser to process, and can therefore be used if caller expects to get a String value next from input.

  Throws:
    `IOException`
    `JsonParseException`

### nextLongValue

    public long nextLongValue(long defaultValue)
                       throws IOException,
                              JsonParseException

  Method that fetches next token (as if calling `nextToken()`) and if it is `JsonToken.VALUE_NUMBER_INT` returns 64-bit long value; otherwise returns specified default value It is functionally equivalent to:

        return (nextToken() == JsonToken.VALUE_NUMBER_INT) ? getLongValue() : defaultValue;

  but may be faster for parser to process, and can therefore be used if caller expects to get a String value next from input.

  Throws:
    `IOException`
    `JsonParseException`

### nextBooleanValue

    public Boolean nextBooleanValue()
                             throws IOException,
                                    JsonParseException

  Method that fetches next token (as if calling `nextToken()`) and if it is `JsonToken.VALUE_TRUE` or `JsonToken.VALUE_FALSE` returns matching Boolean value; otherwise return null. It is functionally equivalent to:

        JsonToken t = nextToken();
        if (t == JsonToken.VALUE_TRUE) return Boolean.TRUE;
        if (t == JsonToken.VALUE_FALSE) return Boolean.FALSE;
        return null;

  but may be faster for parser to process, and can therefore be used if caller expects to get a String value next from input.

  Throws:
    `IOException`
    `JsonParseException`

### skipChildren

    public abstract JsonParser skipChildren()
                                     throws IOException,
                                            JsonParseException

  Method that will skip all child tokens of an array or object token that the parser currently points to, iff stream points to `JsonToken.START_OBJECT` or `JsonToken.START_ARRAY`. If not, it will do nothing. After skipping, stream will point to matching `JsonToken.END_OBJECT` or `JsonToken.END_ARRAY` (possibly skipping nested pairs of START/END OBJECT/ARRAY tokens as well as value tokens). The idea is that after calling this method, application will call `nextToken()` to point to the next available token, if any.

  Throws:
    `IOException`
    `JsonParseException`

### isClosed

    public abstract boolean isClosed()

  Method that can be called to determine whether this parser is closed or not. If it is closed, no new tokens can be retrieved by calling `nextToken()` (and the underlying stream may be closed). Closing may be due to an explicit call to `close()` or because parser has encountered end of input.

### getCurrentToken

    public abstract JsonToken getCurrentToken()

  Accessor to find which token parser currently points to, if any; null will be returned if none. If return value is non-null, data associated with the token is available via other accessor methods.

  Returns:
    Type of the token this parser currently points to, if any: null before any tokens have been read, and after end-of-input has been encountered, as well as if the current token has been explicitly cleared.

### hasCurrentToken

    public abstract boolean hasCurrentToken()

  Method for checking whether parser currently points to a token (and data for that token is available). Equivalent to check for `parser.getCurrentToken() != null`.

  Returns:
    True if the parser just returned a valid token via `nextToken()`; false otherwise (parser was just constructed, encountered end-of-input and returned null from `nextToken()`, or the token has been consumed)

### getCurrentName

    public abstract String getCurrentName()
                                   throws IOException,
                                          JsonParseException

  Method that can be called to get the name associated with the current token: for `JsonToken.FIELD_NAME`s it will be the same as what `getText()` returns; for field values it will be preceding field name; and for others (array values, root-level values) null.

  Throws:
    `IOException`
    `JsonParseException`

### getParsingContext

    public abstract JsonStreamContext getParsingContext()

  Method that can be used to access current parsing context reader is in. There are 3 different types: root, array and object contexts, with slightly different available information. Contexts are hierarchically nested, and can be used for example for figuring out part of the input document that correspond to specific array or object (for highlighting purposes, or error reporting). Contexts can also be used for simple xpath-like matching of input, if so desired.

### getTokenLocation

    public abstract JsonLocation getTokenLocation()

  Method that return the starting location of the current token; that is, position of the first character from input that starts the current token.

### getCurrentLocation

    public abstract JsonLocation getCurrentLocation()

  Method that returns location of the last processed character; usually for error reporting purposes.

### isExpectedStartArrayToken

    public boolean isExpectedStartArrayToken()

  Specialized accessor that can be used to verify that the current token indicates start array (usually meaning that current token is `JsonToken.START_ARRAY`) when start array is expected. For some specialized parsers this can return true for other cases as well; this is usually done to emulate arrays.

  Default implementation is equivalent to:

         getCurrentToken() == JsonToken.START_ARRAY

  but may be overridden by custom parser implementations.

  Returns:
    True if the current token can be considered as a start-array marker (such `JsonToken.START_ARRAY`); false if not.

### clearCurrentToken

    public abstract void clearCurrentToken()

  Method called to "consume" the current token by effectively removing it so that `hasCurrentToken()` returns false, and `getCurrentToken()` null). Cleared token value can still be accessed by calling `getLastClearedToken()` (if absolutely needed), but usually isn't.

  Method was added to be used by the optional data binder, since it has to be able to consume last token used for binding (so that it will not be used again).

### getLastClearedToken

    public abstract JsonToken getLastClearedToken()

  Method that can be called to get the last token that was cleared using `clearCurrentToken()`. This is not necessarily the latest token read. Will return null if no tokens have been cleared, or if parser has been closed.

### overrideCurrentName

    public abstract void overrideCurrentName(String name)

  Method that can be used to change what is considered to be the current (field) name. May be needed to support non-JSON data formats or unusual binding conventions; not needed for typical processing.

  Note that use of this method should only be done as sort of last resort, as it is a work-around for regular operation.

  Parameters:
    `name` - Name to use as the current name; may be null.
  Since:
    2.0

### getText

    public abstract String getText()
                            throws IOException,
                                   JsonParseException

  Method for accessing textual representation of the current token; if no current token (before first call to `nextToken()`, or after encountering end-of-input), returns null. Method can be called for any token type.

  Throws:
    `IOException`
    `JsonParseException`

### getTextCharacters

    public abstract char[] getTextCharacters()
                                      throws IOException,
                                             JsonParseException

  Method similar to `getText()`, but that will return underlying (unmodifiable) character array that contains textual value, instead of constructing a String object to contain this information. Note, however, that:
  - Textual contents are not guaranteed to start at index 0 (rather, call `getTextOffset()`) to know the actual offset
  - Length of textual contents may be less than the length of returned buffer: call `getTextLength()` for actual length of returned content.

  Note that caller MUST NOT modify the returned character array in any way -- doing so may corrupt current parser state and render parser instance useless.

  The only reason to call this method (over `getText()`) is to avoid construction of a String object (which will make a copy of contents).

  Throws:
    `IOException`
    `JsonParseException`

### getTextLength

    public abstract int getTextLength()
                               throws IOException,
                                      JsonParseException

  Accessor used with `getTextCharacters()`, to know length of String stored in returned buffer.

  Returns:
    Number of characters within buffer returned by `getTextCharacters()` that are part of textual content of the current token.
  Throws:
    `IOException`
    `JsonParseException`

### getTextOffset

    public abstract int getTextOffset()
                               throws IOException,
                                      JsonParseException

  Accessor used with `getTextCharacters()`, to know offset of the first text content character within buffer.

  Returns:
    Offset of the first character within buffer returned by `getTextCharacters()` that is part of textual content of the current token.
  Throws:
    `IOException`
    `JsonParseException`

### hasTextCharacters

    public abstract boolean hasTextCharacters()

  Method that can be used to determine whether calling of `getTextCharacters()` would be the most efficient way to access textual content for the event parser currently points to.

  Default implementation simply returns false since only actual implementation class has knowledge of its internal buffering state. Implementations are strongly encouraged to properly override this method, to allow efficient copying of content by other code.

  Returns:
    True if parser currently has character array that can be efficiently returned via `getTextCharacters()`; false means that it may or may not exist

### getNumberValue

    public abstract Number getNumberValue()
                                   throws IOException,
                                          JsonParseException

  Generic number value accessor method that will work for all kinds of numeric values. It will return the optimal (simplest/smallest possible) wrapper object that can express the numeric value just parsed.

  Throws:
    `IOException`
    `JsonParseException`

### getNumberType

    public abstract JsonParser.NumberType getNumberType()
                                                 throws IOException,
                                                        JsonParseException

  If current token is of type `JsonToken.VALUE_NUMBER_INT` or `JsonToken.VALUE_NUMBER_FLOAT`, returns one of `JsonParser.NumberType` constants; otherwise returns null.

  Throws:
    `IOException`
    `JsonParseException`

### getByteValue

    public byte getByteValue()
                      throws IOException,
                             JsonParseException

  Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a value of Java byte primitive type. It can also be called for `JsonToken.VALUE_NUMBER_FLOAT`; if so, it is equivalent to calling `getDoubleValue()` and then casting; except for possible overflow/underflow exception.

  Note: if the resulting integer value falls outside range of Java byte, a `JsonParseException` will be thrown to indicate numeric overflow/underflow.

  Throws:
    `IOException`
    `JsonParseException`

### getShortValue

    public short getShortValue()
                        throws IOException,
                               JsonParseException

  Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a value of Java short primitive type. It can also be called for `JsonToken.VALUE_NUMBER_FLOAT`; if so, it is equivalent to calling `getDoubleValue()` and then casting; except for possible overflow/underflow exception.

  Note: if the resulting integer value falls outside range of Java short, a `JsonParseException` will be thrown to indicate numeric overflow/underflow.

  Throws:
    `IOException`
    `JsonParseException`

### getIntValue

    public abstract int getIntValue()
                             throws IOException,
                                    JsonParseException

  Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a value of Java int primitive type. It can also be called for `JsonToken.VALUE_NUMBER_FLOAT`; if so, it is equivalent to calling `getDoubleValue()` and then casting; except for possible overflow/underflow exception.

  Note: if the resulting integer value falls outside range of Java int, a `JsonParseException` may be thrown to indicate numeric overflow/underflow.

  Throws:
    `IOException`
    `JsonParseException`

### getLongValue

    public abstract long getLongValue()
                               throws IOException,
                                      JsonParseException

  Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a Java long primitive type. It can also be called for `JsonToken.VALUE_NUMBER_FLOAT`; if so, it is equivalent to calling `getDoubleValue()` and then casting to int; except for possible overflow/underflow exception.

  Note: if the token is an integer, but its value falls outside of range of Java long, a `JsonParseException` may be thrown to indicate numeric overflow/underflow.

  Throws:
    `IOException`
    `JsonParseException`

### getBigIntegerValue

    public abstract BigInteger getBigIntegerValue()
                                           throws IOException,
                                                  JsonParseException

  Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can not be used as a Java long primitive type due to its magnitude. It can also be called for `JsonToken.VALUE_NUMBER_FLOAT`; if so, it is equivalent to calling `getDecimalValue()` and then constructing a `BigInteger` from that value.

  Throws:
    `IOException`
    `JsonParseException`

### getFloatValue

    public abstract float getFloatValue()
                                 throws IOException,
                                        JsonParseException

  Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` and it can be expressed as a Java float primitive type. It can also be called for `JsonToken.VALUE_NUMBER_INT`; if so, it is equivalent to calling `getLongValue()` and then casting; except for possible overflow/underflow exception.

  Note: if the value falls outside of range of Java float, a `JsonParseException` will be thrown to indicate numeric overflow/underflow.

  Throws:
    `IOException`
    `JsonParseException`

### getDoubleValue

    public abstract double getDoubleValue()
                                   throws IOException,
                                          JsonParseException

  Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` and it can be expressed as a Java double primitive type. It can also be called for `JsonToken.VALUE_NUMBER_INT`; if so, it is equivalent to calling `getLongValue()` and then casting; except for possible overflow/underflow exception.

  Note: if the value falls outside of range of Java double, a `JsonParseException` will be thrown to indicate numeric overflow/underflow.

  Throws:
    `IOException`
    `JsonParseException`

### getDecimalValue

    public abstract BigDecimal getDecimalValue()
                                        throws IOException,
                                               JsonParseException

  Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` or `JsonToken.VALUE_NUMBER_INT`. No under/overflow exceptions are ever thrown.

  Throws:
    `IOException`
    `JsonParseException`

### getBooleanValue

    public boolean getBooleanValue()
                            throws IOException,
                                   JsonParseException

  Convenience accessor that can be called when the current token is `JsonToken.VALUE_TRUE` or `JsonToken.VALUE_FALSE`.

  Note: if the token is not of above-mentioned boolean types, an integer, but its value falls outside of range of Java long, a `JsonParseException` may be thrown to indicate numeric overflow/underflow.

  Throws:
    `IOException`
    `JsonParseException`

### getEmbeddedObject

    public abstract Object getEmbeddedObject()
                                      throws IOException,
                                             JsonParseException

  Accessor that can be called if (and only if) the current token is `JsonToken.VALUE_EMBEDDED_OBJECT`. For other token types, null is returned.

  Note: only some specialized parser implementations support embedding of objects (usually ones that are facades on top of non-streaming sources, such as object trees).

  Throws:
    `IOException`
    `JsonParseException`

### getBinaryValue

    public abstract byte[] getBinaryValue(Base64Variant b64variant)
                                   throws IOException,
                                          JsonParseException

  Method that can be used to read (and consume -- results may not be accessible using other methods after the call) base64-encoded binary data included in the current textual JSON value. It works similar to getting String value via `getText()` and decoding result (except for decoding part), but should be significantly more performant.

  Note that non-decoded textual contents of the current token are not guaranteed to be accessible after this method is called. Current implementation, for example, clears up textual content during decoding. Decoded binary content, however, will be retained until parser is advanced to the next event.

  Parameters:
    `b64variant` - Expected variant of base64 encoded content (see `Base64Variants` for definitions of "standard" variants).
  Returns:
    Decoded binary data
  Throws:
    `IOException`
    `JsonParseException`

### getBinaryValue

    public byte[] getBinaryValue()
                          throws IOException,
                                 JsonParseException

  Convenience alternative to `getBinaryValue(Base64Variant)` that defaults to using `Base64Variants.getDefaultVariant()` as the default encoding.

  Throws:
    `IOException`
    `JsonParseException`

### readBinaryValue

    public int readBinaryValue(OutputStream out)
                        throws IOException,
                               JsonParseException

  Method that can be used as an alternative to `getBigIntegerValue()`, especially when value can be large. The main difference (beyond method of returning content using `OutputStream` instead of as byte array) is that content will NOT remain accessible after method returns: any content processed will be consumed and is not buffered in any way. If caller needs buffering, it has to implement it.

  Parameters:
    `out` - Output stream to use for passing decoded binary data
  Returns:
    Number of bytes that were decoded and written via `OutputStream`
  Throws:
    `IOException`
    `JsonParseException`
  Since:
    2.1

### readBinaryValue

    public int readBinaryValue(Base64Variant b64variant,
                               OutputStream out)
                        throws IOException,
                               JsonParseException

  Similar to `readBinaryValue(OutputStream)` but allows explicitly specifying base64 variant to use.

  Parameters:
    `b64variant` - base64 variant to use
    `out` - Output stream to use for passing decoded binary data
  Returns:
    Number of bytes that were decoded and written via `OutputStream`
  Throws:
    `IOException`
    `JsonParseException`
  Since:
    2.1

### getValueAsInt

    public int getValueAsInt()
                      throws IOException,
                             JsonParseException

  Method that will try to convert value of current token to a int. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

  If representation can not be converted to an int (including structured type markers like start/end Object/Array) default value of 0 will be returned; no exceptions are thrown.

  Throws:
    `IOException`
    `JsonParseException`

### getValueAsInt

    public int getValueAsInt(int defaultValue)
                      throws IOException,
                             JsonParseException

  Method that will try to convert value of current token to a int. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

  If representation can not be converted to an int (including structured type markers like start/end Object/Array) specified defaultValue will be returned; no exceptions are thrown.

  Throws:
    `IOException`
    `JsonParseException`

### getValueAsLong

    public long getValueAsLong()
                        throws IOException,
                               JsonParseException

  Method that will try to convert value of current token to a long. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

  If representation can not be converted to an int (including structured type markers like start/end Object/Array) default value of 0 will be returned; no exceptions are thrown.

  Throws:
    `IOException`
    `JsonParseException`

### getValueAsLong

    public long getValueAsLong(long defaultValue)
                        throws IOException,
                               JsonParseException

  Method that will try to convert value of current token to a long. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

  If representation can not be converted to an int (including structured type markers like start/end Object/Array) specified defaultValue will be returned; no exceptions are thrown.

  Throws:
    `IOException`
    `JsonParseException`

### getValueAsDouble

    public double getValueAsDouble()
                            throws IOException,
                                   JsonParseException

  Method that will try to convert value of current token to a Java double. Numbers are coerced using default Java rules; booleans convert to 0.0 (false) and 1.0 (true), and Strings are parsed using default Java language integer parsing rules.

  If representation can not be converted to an int (including structured types like Objects and Arrays), default value of 0.0 will be returned; no exceptions are thrown.

  Throws:
    `IOException`
    `JsonParseException`

### getValueAsDouble

    public double getValueAsDouble(double defaultValue)
                            throws IOException,
                                   JsonParseException

  Method that will try to convert value of current token to a Java double. Numbers are coerced using default Java rules; booleans convert to 0.0 (false) and 1.0 (true), and Strings are parsed using default Java language integer parsing rules.

  If representation can not be converted to an int (including structured types like Objects and Arrays), specified defaultValue will be returned; no exceptions are thrown.

  Throws:
    `IOException`
    `JsonParseException`

### getValueAsBoolean

    public boolean getValueAsBoolean()
                              throws IOException,
                                     JsonParseException

  Method that will try to convert value of current token to a boolean. JSON booleans map naturally; integer numbers other than 0 map to true, and 0 maps to false and Strings 'true' and 'false' map to corresponding values.

  If representation can not be converted to a boolean value (including structured types like Objects and Arrays), default value of false will be returned; no exceptions are thrown.

  Throws:
    `IOException`
    `JsonParseException`

### getValueAsBoolean

    public boolean getValueAsBoolean(boolean defaultValue)
                              throws IOException,
                                     JsonParseException

  Method that will try to convert value of current token to a boolean. JSON booleans map naturally; integer numbers other than 0 map to true, and 0 maps to false and Strings 'true' and 'false' map to corresponding values.

  If representation can not be converted to a boolean value (including structured types like Objects and Arrays), specified defaultValue will be returned; no exceptions are thrown.

  Throws:
    `IOException`
    `JsonParseException`

### getValueAsString

    public String getValueAsString()
                            throws IOException,
                                   JsonParseException

  Method that will try to convert value of current token to a `String`. JSON Strings map naturally; scalar values get converted to their textual representation. If representation can not be converted to a String value (including structured types like Objects and Arrays and null token), default value of null will be returned; no exceptions are thrown.

  Throws:
    `IOException`
    `JsonParseException`
  Since:
    2.1

### getValueAsString

    public abstract String getValueAsString(String defaultValue)
                                     throws IOException,
                                            JsonParseException

  Method that will try to convert value of current token to a `String`. JSON Strings map naturally; scalar values get converted to their textual representation. If representation can not be converted to a String value (including structured types like Objects and Arrays and null token), specified default value will be returned; no exceptions are thrown.

  Throws:
    `IOException`
    `JsonParseException`
  Since:
    2.1

### readValueAs

    public <T> T readValueAs(Class<T> valueType)
                  throws IOException,
                         JsonProcessingException

  Method to deserialize JSON content into a non-container type (it can be an array type, however): typically a bean, array or a wrapper type (like `Boolean`). Note: method can only be called if the parser has an object codec assigned; this is true for parsers constructed by `MappingJsonFactory` (from "jackson-databind" jar) but not for `JsonFactory` (unless its `setCodec` method has been explicitly called).

  This method may advance the event stream, for structured types the current token will be the closing end marker (END_ARRAY, END_OBJECT) of the bound structure. For non-structured Json types (and for `JsonToken.VALUE_EMBEDDED_OBJECT`) stream is not advanced.

  Note: this method should NOT be used if the result type is a container (`Collection` or `Map`. The reason is that due to type erasure, key and value types can not be introspected when using this method.

  Throws:
    `IOException`
    `JsonProcessingException`

### readValueAs

    public <T> T readValueAs(TypeReference<?> valueTypeRef)
                  throws IOException,
                         JsonProcessingException

  Method to deserialize JSON content into a Java type, reference to which is passed as argument. Type is passed using so-called "super type token" and specifically needs to be used if the root type is a parameterized (generic) container type. Note: method can only be called if the parser has an object codec assigned; this is true for parsers constructed by `MappingJsonFactory` (defined in 'jackson-databind' bundle) but not for `JsonFactory` (unless its `setCodec` method has been explicitly called).

  This method may advance the event stream, for structured types the current token will be the closing end marker (END_ARRAY, END_OBJECT) of the bound structure. For non-structured Json types (and for `JsonToken.VALUE_EMBEDDED_OBJECT`) stream is not advanced.

  Throws:
    `IOException`
    `JsonProcessingException`

### readValuesAs

    public <T> Iterator<T> readValuesAs(Class<T> valueType)
                             throws IOException,
                                    JsonProcessingException

  Method for reading sequence of Objects from parser stream, all with same specified value type.

  Throws:
    `IOException`
    `JsonProcessingException`

### readValuesAs

    public <T> Iterator<T> readValuesAs(TypeReference<?> valueTypeRef)
                             throws IOException,
                                    JsonProcessingException

  Method for reading sequence of Objects from parser stream, all with same specified value type.

  Throws:
    `IOException`
    `JsonProcessingException`

### readValueAsTree

    public <T extends TreeNode> T readValueAsTree()
                                       throws IOException,
                                              JsonProcessingException

  Method to deserialize JSON content into equivalent "tree model", represented by root `TreeNode` of resulting model. For JSON Arrays it will an array node (with child nodes), for objects object node (with child nodes), and for other types matching leaf node type

  Throws:
    `IOException`
    `JsonProcessingException`

### _constructError

    protected JsonParseException _constructError(String msg)

  Helper method for constructing `JsonParseException`s based on current state of the parser

### _reportUnsupportedOperation

    protected void _reportUnsupportedOperation()

  Helper method to call for operations that are not supported by parser implementation.

  Since:
    2.1

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2012 FasterXML. All Rights Reserved.